#!/bin/sh
### BEGIN INIT INFO
# Provides:          boot_complete.sh
# Required-Start:
# Required-Stop:     maxwell-teardown
# Should-Stop:       $network $portmap
# Default-Start:     5
# Default-Stop:      6 7
# Short-Description: Creates file in /var/run tmpfs to inform that bootup
#                    process is completed
### END INIT INFO

source maxwell-log-functions.sh

PATH=/sbin:/bin:/usr/sbin:/usr/bin
PROPCLI=/usr/sbin/propcli

# Create boot_complete file
touch /var/run/boot_complete

# Restart syslog when boot complete to reconfigure it if needed
/etc/init.d/syslog restart

# Set proper timezone
TIMEZONE=$($PROPCLI get System.DateAndTime.TimeZone)

if [ $? -eq 0 ]; then
	TIMEZONE=$(cut -d '.' -f 2 <<< $TIMEZONE)
	TIMEZONE_FILE="/usr/share/zoneinfo/$TIMEZONE"
	if [ -f $TIMEZONE_FILE ]; then
		ln -sf $TIMEZONE_FILE /etc/localtime
		echo $TIMEZONE > /etc/timezone
		log_info "Time zone changed to: $TIMEZONE"
	else
		log_warning "Wrong timezone info: $TIMEZONE"
	fi
else
	log_error "Can't get timezone from NVM"
fi
