#!/bin/sh

### BEGIN INIT INFO
# Provides:          maxwell_model
# Required-Start:
# Required-Stop:
# Default-Start:     5
# Default-Stop:
# Short-Description: Prints device model info
# Description:
### END INIT INFO

. /etc/init.d/init-functions

board=`cat /proc/device-tree/model | cut -d" " -f3,4`
case $board in
	"Maxwell Basic")
		echo "$board PRO:elmeg IP620" > /etc/model
		log_success_msg `cat /etc/model`
		;;
	"Maxwell 2")
		echo "$board PRO:elmeg IP625" > /etc/model
		log_success_msg `cat /etc/model`
		;;
	"Maxwell 3")
		echo "$board PRO:elmeg IP630" > /etc/model
		log_success_msg `cat /etc/model`
		;;
	*)
		log_error_msg "Not recognized device model"
		;;
esac
