#!/bin/bash

# Copyright 2018 Gigaset Communications GmbH

IPTABLE_NAME="dnsroot"

delete_rules()
{
	while [ true ]; do
		$(iptables -w -C $1 &>/dev/null)
		if [ $? -eq 0 ]; then
			$(iptables -w -D $1)
		else
			break
		fi
	done
}

# First check table exists, create if not
iptables -w -S | grep "$IPTABLE_NAME" &>/dev/null
if [ $? -ne 0 ]; then
	iptables -w -N dnsroot
fi

# Flush IP table
iptables -w -F $IPTABLE_NAME
delete_rules "OUTPUT -j $IPTABLE_NAME"

if [ "$1" == "Disabled" ]; then
	iptables -A $IPTABLE_NAME -p udp --dport 53 -m u32 --u32 "0x28=0x0100" -j DROP
fi

iptables -w -A OUTPUT -j $IPTABLE_NAME
