#!/bin/sh

# Copyright 2016-2017 Gigaset Communications GmbH
#-----------------------------------------

LOG_PREFIX="firmware-update-cleanup"
LOG_FILE="/config/clean-up.log"

source maxwell-log-functions.sh

#-----------------------------------------

log()
{
	if [ -f /usr/bin/logger ]; then
		log_info "$1"
	else
		echo "${LOG_PREFIX}: $1" >> ${LOG_FILE}
	fi
}

#-----------------------------------------

test -f ${LOG_FILE} && rm -f ${LOG_FILE}
log "Clean up utils script"

# Redirect stderr of executed programs to /dev/null
exec 2>/dev/null

result=0
log "Cleaning firmware update directory"
cleaning_dir="/config/tmp"
cleaning_partition="ubi0_2"
mount_dev=$(df -P ${cleaning_dir} | tail -1 | cut -d' ' -f 1)

if [[ ${mount_dev} =~ ${cleaning_partition} ]]; then
	log "Cleaning content of ${cleaning_dir} located on ${cleaning_partition} partition"
	rm -rf ${cleaning_dir}/*
	result=0
else
	log "Fail: ${cleaning_dir} is not located on ${cleaning_partition} partition"
	result=1
fi

log "Clean up utils script exit code: ${result}"

exit ${result}
